//---------------------------------------------------------------------------

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
#include <stdio.h>
#include "..\Lib\Dongle_API.h"
int main(int argc, char* argv[])
{
	int   nCount = 0;
	int   i = 0, j = 0;	
	int   nLen = 0;
	BYTE  seed[250]; 
	DWORD dwRet = 0;
	char AdminPin [] = "FFFFFFFFFFFFFFFF";//ĬϿPIN
	int nRemainCount = 0;
	BYTE pOutData[16];//㷨̶Ϊ16ֽ
	
	DONGLE_HANDLE hDongle = NULL;

	for (i = 0; i < 250; i++) seed[i] = i;

	//ö
	dwRet = Dongle_Enum(NULL, &nCount);
	printf("Enum %d Rockey ARM. \n", nCount);
	
	//
	dwRet = Dongle_Open(&hDongle, 0);
	printf("Open Rockey ARM. Return : 0x%08X . \n", dwRet);

	//֤PIN
	dwRet = Dongle_VerifyPIN(hDongle, FLAG_ADMINPIN, AdminPin, &nRemainCount);
	printf("Verify Admin PIN. Return: 0x%08X\n", dwRet);

	//3
	dwRet = Dongle_LimitSeedCount(hDongle, 3);
	printf("Set seed limit: 3 Times. Return: 0x%08X\n", dwRet);

	//ص̬
	dwRet = Dongle_ResetState(hDongle);
	printf("Reset COS State. Return: 0x%08X\n", dwRet);

	//,Ĵ
	for (i = 0; i < 4; i++)
	{		
		memset(pOutData, 0, 16);
		dwRet = Dongle_Seed(hDongle, seed, 250, pOutData);
		if (DONGLE_SUCCESS == dwRet)
		{
			printf("Result[%d]: ", i);
			for (j = 0 ; j < 16; j++)
			{
				printf("%02X ", pOutData[j]);
			}
			printf("\n");
		}
		else
		{
			printf("the count = %d failed!\n", (i+1));
		}
	}

	//֤PIN
	dwRet = Dongle_VerifyPIN(hDongle, FLAG_ADMINPIN, AdminPin, &nRemainCount);
	printf("Verify Admin PIN. Return: 0x%08X\n", dwRet);
	
	//3
	dwRet = Dongle_LimitSeedCount(hDongle, -1);
	printf("Set seed unlimited(-1). Return: 0x%08X\n", dwRet);

	//رռ
	dwRet = Dongle_Close(hDongle);
	printf("Close Rockey ARM. Return: 0x%08X\n", dwRet);

	return 0;
}
//---------------------------------------------------------------------------
