//---------------------------------------------------------------------------

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
#include <stdio.h>
#include <malloc.h>
#include "data.h"
#include "..\Lib\Dongle_API.h"
int main(int argc, char* argv[])
{
	int   nCount = 0;
	int   i = 0, j = 0;	
	int   nLen = 0;
	DWORD dwRet = 0;
	char AdminPin [] = "FFFFFFFFFFFFFFFF";//ĬϿPIN
	int  nRemainCount = 0;
	BYTE buffer[1024];
	int  nOutDataLen = 1024;
	int  nFunc = -1;
	int  nTotal = 0;
	BYTE HID[8] = {0x11, 0x22, 0x33, 0x44, 0x55, 0x66, 0x77, 0x88};//󶨵Ӳк(HID)
		
	DONGLE_HANDLE hDongle = NULL;	
	FILE *fp = NULL;
	RSA_PUBLIC_KEY rsaPub;
	RSA_PRIVATE_KEY rsaPri;
	
	fp = fopen("update.Rsapub", "rb");
	if(NULL == fp) return 0;
	fread(&rsaPub, 1, sizeof(RSA_PUBLIC_KEY), fp);
	fclose(fp);

	fp = fopen("update.Rsapri", "rb");
	if(NULL == fp) return 0;
	fread(&rsaPri, 1, sizeof(RSA_PRIVATE_KEY), fp);
	fclose(fp);
	fp = NULL;
    fp = fopen("update.RyArmUdp", "wb");
	if(NULL == fp) return 0;
	
	//ö
	dwRet = Dongle_Enum(NULL, &nCount);
	printf("Enum %d Rockey ARM. \n", nCount);
	
	//
	dwRet = Dongle_Open(&hDongle, 0);
	printf("Open Rockey ARM. Return : 0x%08X . \n", dwRet);
	
	//֤PIN
	dwRet = Dongle_VerifyPIN(hDongle, FLAG_ADMINPIN, AdminPin, &nRemainCount);
	printf("Verify Admin PIN. Return: 0x%08X\n", dwRet);

	//Զ˽Կû
	dwRet = Dongle_SetUpdatePriKey(hDongle, &rsaPri);
	printf("Set update private key. Return: 0x%08X\n", dwRet);

	// - ()ļ
	byte createData[1024];
	memset(createData, 0, 1024);
	nTotal = 1024;
	nFunc = UPDATE_FUNC_CreateFile; 
	DATA_FILE_ATTR dataAttr;
	dataAttr.m_Size = 1024;
	dataAttr.m_Lic.m_Read_Priv = 1;
	dataAttr.m_Lic.m_Write_Priv = 1;
	memset(buffer, 0, 1024);
	memcpy(buffer, &dataAttr, sizeof(DATA_FILE_ATTR));
	dwRet = Dongle_MakeUpdatePacket(hDongle, NULL, nFunc, FILE_DATA, 0x1122, 0, buffer, sizeof(DATA_FILE_ATTR), &rsaPub,  createData, &nOutDataLen);
	printf("make update data [CreateFile]. Return: 0x%08X\n", dwRet);
	fwrite(createData,1,1024,fp);
	fflush(fp);

	// - д()ļ
	byte writeData[2048];
	memset(writeData, 0, 2048);
	nOutDataLen = 2*1024;
	memset(buffer, 0x12, 1024);//д
	nFunc = UPDATE_FUNC_WriteFile;	
	dwRet = Dongle_MakeUpdatePacket(hDongle, NULL, nFunc, FILE_DATA, 0x1122, 0, buffer, 1024, &rsaPub, writeData, &nOutDataLen);
	printf("make update data [WriteFile]. Return: 0x%08X\n", dwRet);
	fwrite(writeData,1,2048,fp);
	fflush(fp);
	
	// - ļȨ
	byte licData[1024];
	memset(licData, 0, 1024);
	nOutDataLen = 1024;
	DATA_LIC dataLic;
	dataLic.m_Read_Priv = 0;
	dataLic.m_Write_Priv = 1;
	memset(buffer, 0, 1024);//д
	memcpy(buffer, &dataLic, sizeof(DATA_LIC));
	nFunc = UPDATE_FUNC_FileLic;
	dwRet = Dongle_MakeUpdatePacket(hDongle, NULL, nFunc, FILE_DATA, 0x1122, 0, buffer, sizeof(DATA_LIC), &rsaPub, licData, &nOutDataLen);
	printf("make update data [FileLic]. Return: 0x%08X\n", dwRet);
	fwrite(licData,1,1024,fp);
	fflush(fp);
	
	// - ɾ()ļ
	byte delData[1024];
	memset(delData, 0,1024);
	nOutDataLen = 1024;
	nFunc = UPDATE_FUNC_DeleteFile;	
	dwRet = Dongle_MakeUpdatePacket(hDongle, NULL, nFunc, FILE_DATA, 0x1122, 0, buffer, 0, &rsaPub, delData, &nOutDataLen);
	printf("make update data [DeleteFile]. Return: 0x%08X\n", dwRet);
	fwrite(delData,1,1024,fp);
	fflush(fp);
	
	// - ؿִг
	byte downloadData[4096];
	memset(downloadData ,0, 4096);
	nOutDataLen = (4*1024);
	EXE_FILE_INFO exeFileInfo;
	nCount = 1;//ִļ
	exeFileInfo.m_dwSize = EXE_SIZE_1;
	exeFileInfo.m_pData = g_progExeFile1;
	exeFileInfo.m_Priv = 0;
	exeFileInfo.m_wFileID = 0x1100;
	memset(buffer, 0, 1024);
	memcpy(buffer, &exeFileInfo, nCount * sizeof(EXE_FILE_INFO));
	nFunc = UPDATE_FUNC_DownloadExe;
	dwRet = Dongle_MakeUpdatePacket(hDongle, NULL, nFunc, FILE_EXE, 0x1122, 0, buffer, (nCount * sizeof(EXE_FILE_INFO)), &rsaPub, downloadData, &nOutDataLen);
	printf("make update data [DownloadExe]. Return: 0x%08X\n", dwRet);
	fwrite(downloadData,1,4096,fp);
	fflush(fp);

	// - ûPIN == Ӳк
	byte unlockData[1024];
	memset(unlockData, 0, 1024);
	nOutDataLen = 1024;
	char cHid[9];
	memset(cHid, 0, 9);
	memcpy(cHid, HID, 8);
	nFunc = UPDATE_FUNC_UnlockUserPin;	
	dwRet = Dongle_MakeUpdatePacket(hDongle, cHid, nFunc, 0, 0, 0, 0, 0, &rsaPub, unlockData, &nOutDataLen);
	printf("make update data [UnlockUserPin]. Return: 0x%08X\n", dwRet);
	fwrite(unlockData,1,1024,fp);
	fflush(fp);


	// - ʹ
	byte deadlineData[1024];
	memset(deadlineData, 0, 1024);
	nOutDataLen = 1024;
	DWORD dwTime = 24;//24Сʱ
	memset(buffer, 0, 1024);
	memcpy(buffer, &dwTime, sizeof(DWORD));
	nFunc = UPDATE_FUNC_Deadline;	
	dwRet = Dongle_MakeUpdatePacket(hDongle, NULL, nFunc, 0, 0, 0, buffer, sizeof(DWORD), &rsaPub, deadlineData, &nOutDataLen);
	printf("make update data [Deadline]. Return: 0x%08X\n", dwRet);
	fwrite(deadlineData,1,1024,fp);
	fflush(fp);

	//رռ
	dwRet = Dongle_Close(hDongle);
	printf("Close Rockey ARM. Return: 0x%08X\n", dwRet);

	//رļ
	fclose(fp);
	fp = NULL;

	return 0;
}
//---------------------------------------------------------------------------
