//---------------------------------------------------------------------------

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
#include <stdio.h>
#include "..\\Lib\\Dongle_API.h" 

int main(int argc, char* argv[])
{
	DWORD dwRet = 0;
	int nCount = 0;
	DONGLE_HANDLE hDongle = NULL;
	DONGLE_INFO *pDongleInfo = NULL;
	char ch[128];
	
	dwRet = Dongle_Enum(NULL, &nCount);//ö
	if (dwRet != DONGLE_SUCCESS)
	{
		printf("Enum Rockey ARM Failed! Return value: 0x%08X\n", dwRet);
		return 0;
	}
	printf("Enum nCount = %d\n", nCount);

	pDongleInfo = (DONGLE_INFO *)malloc(nCount * sizeof(DONGLE_INFO));
	if (NULL == pDongleInfo)
	{
		printf("malloc memory error!\n");
		return 0;
	}

	dwRet = Dongle_Enum(pDongleInfo, &nCount);//ȡϢ
	if (dwRet != DONGLE_SUCCESS)
	{
		printf("Get Rockey ARM information Failed. Return value: 0x%08X\n", dwRet);
		return 0;
	}

	printf("\n*****************Rockey ARM INFO*******************\n");
	//ʾϢ
	for (int k = 0; k < nCount ; k++)
	{
		
		printf("The index [%d] Rockey ARM information: \n", k);
		printf("Agent ID: 0x%08X. (ID)\n", pDongleInfo[k].m_Agent);
		printf("Dev Type: %02X. (0x00ʾhid豸,0x01ʾccid豸)\n", pDongleInfo[k].m_DevType);

		memset(ch, 0, 128);
		sprintf(ch,"20%02X-%02X-%02X %02X:%02X:%02X",
			pDongleInfo[k].m_BirthDay[0],
			pDongleInfo[k].m_BirthDay[1],
			pDongleInfo[k].m_BirthDay[2],
			pDongleInfo[k].m_BirthDay[3],
			pDongleInfo[k].m_BirthDay[4],
			pDongleInfo[k].m_BirthDay[5]
			);
		printf("Brith day: %s. (ʱ)\n", ch);
		printf("HID: ");
		for (int i = 0; i < 8; i++)
		{
			printf("%02X ", pDongleInfo[k].m_HID[i]);
		}
		printf(". (Ӳк)\n");
		printf("Is Mother Dongle: %d. (Ƿĸ)\n", pDongleInfo[k].m_IsMother);
		printf("PID: 0x%08X. (ƷID)\n", pDongleInfo[k].m_PID);
		printf("Product Type: %02X. (0xFF׼, 0x00ʱ,0x01ʱӵU,0x02׼U)\n", pDongleInfo[k].m_Type);
		printf("UID: 0x%08X. (ûID)\n", pDongleInfo[k].m_UserID);
		printf("COS version: %d.%02d. (COS汾) \n", (pDongleInfo[k].m_Ver >> 8), (pDongleInfo[k].m_Ver & 0x0F));
		printf("\n");
	}

	printf("***************************************************\n");

	dwRet = Dongle_Open(&hDongle, 0);//򿪵1
	printf("Open Rockey ARM . Return value: 0x%08X \n", dwRet);

	dwRet = Dongle_Close(hDongle);//رռ
	printf("Close Rockey ARM . Return value: 0x%08X \n", dwRet);
	

	if (NULL != pDongleInfo)
	{
		free(pDongleInfo);
		pDongleInfo = NULL;
	}

	return 0;
}
//---------------------------------------------------------------------------
