//---------------------------------------------------------------------------

#pragma hdrstop
#include <stdio.h>
#include "..\Lib\Dongle_API.h"

#include "data.h" //ִг
//---------------------------------------------------------------------------

#pragma argsused
int main(int argc, char* argv[])
{
	DWORD dwRet = 0;	
	int nCount = 0;
	int i = 0;	
	BYTE buffer[1020];
	char AdminPin [] = "FFFFFFFFFFFFFFFF";//ĬϿPIN
	int nRemainCount = 0;
	WORD  nInOutDataLen = 0;
	int   nMainRet = 0;
	
	EXE_FILE_INFO exeFileInfo[2];
	DONGLE_HANDLE hDongle = NULL;
	
	//ö
	dwRet = Dongle_Enum(NULL, &nCount);
	printf("Enum %d Rockey ARM. \n", nCount);
	
	//
	dwRet = Dongle_Open(&hDongle, 0);
	printf("Open Rockey ARM. Return : 0x%08X . \n", dwRet);
	
	//֤PIN
	dwRet = Dongle_VerifyPIN(hDongle, FLAG_ADMINPIN, AdminPin, &nRemainCount);
	printf("Verify Admin PIN. Return: 0x%08X\n", dwRet);

	//صĿִг
	//õһļ
	exeFileInfo[0].m_dwSize = EXE_SIZE_1;//ļС
	exeFileInfo[0].m_Priv = 0;//ɵ
	exeFileInfo[0].m_wFileID = 0x1111;//ļID
	exeFileInfo[0].m_pData = g_progExeFile1;

	//õڶļ
	exeFileInfo[1].m_dwSize = EXE_SIZE_2;//ļС
	exeFileInfo[1].m_Priv = 0;//ɵ
	exeFileInfo[1].m_wFileID = 0x2222;//ļID
	exeFileInfo[1].m_pData = g_progExeFile2;

	//ؿִļ
	dwRet = Dongle_DownloadExeFile(hDongle, exeFileInfo, 2);
	printf("Download Exe file. Return: 0x%08X\n", dwRet);

	//пִļ	
	nInOutDataLen = 20;
	memset(buffer, 0, sizeof(buffer));
	dwRet = Dongle_RunExeFile(hDongle, 0x1111, buffer, nInOutDataLen, &nMainRet);
	printf("Run Exe file. Return: 0x%08X\n", dwRet);

	//пִļ
	nInOutDataLen = 32;
	dwRet = Dongle_RunExeFile(hDongle, 0x2222, buffer, nInOutDataLen, &nMainRet);
	printf("Run Exe file. Return: 0x%08X\n", dwRet);

	//رռ
	dwRet = Dongle_Close(hDongle);
	printf("Close Rockey ARM Dongle. Return: 0x%08X\n", dwRet);

	return 0;
}
//---------------------------------------------------------------------------
