//---------------------------------------------------------------------------

#pragma hdrstop
#include <stdio.h>
#include "..\Lib\Dongle_API.h"
//---------------------------------------------------------------------------

#pragma argsused
int main(int argc, char* argv[])
{
	DWORD dwRet = 0;	
	int nCount = 0;
	BYTE seed[32];
	char cPid[9];
	char cAdminPin[17];
	char AdminPin [] = "FFFFFFFFFFFFFFFF";//ĬϿPIN
	char UserPin [] = "12345678";
	int nRemainCount = 0;
		
	EXE_FILE_INFO exeFileInfo[2];
	DONGLE_HANDLE hDongle = NULL;
	
	//ö
	dwRet = Dongle_Enum(NULL, &nCount);
	printf("Enum %d Rockey ARM. \n", nCount);
	
	//
	dwRet = Dongle_Open(&hDongle, 0);
	printf("Open Rockey ARM. Return : 0x%08X . \n", dwRet);
	
	//֤PIN
	dwRet = Dongle_VerifyPIN(hDongle, FLAG_ADMINPIN, AdminPin, &nRemainCount);
	printf("Verify Admin PIN. Return: 0x%08X\n", dwRet);

	//ΨһһҪԱȨ
	memset(seed, 0x11, 32);
	memset(cPid, 0, 9);
	memset(cAdminPin, 0, 17);
	dwRet = Dongle_GenUniqueKey(hDongle, 32, seed, cPid, cAdminPin);
	printf("Gen unique key. Return: 0x%08X\n", dwRet);

	//֤ûPIN
	nRemainCount = 0;
	dwRet = Dongle_VerifyPIN(hDongle, FLAG_USERPIN, UserPin, &nRemainCount);
	printf("Verify New Admin PIN. Return: 0x%08X\n", dwRet);

	//ָ״̬
	dwRet = Dongle_ResetState(hDongle);
	printf("Reset COS state. Return: 0x%08X\n", dwRet);


	//֤PIN
	nRemainCount = 0;
	dwRet = Dongle_VerifyPIN(hDongle, FLAG_ADMINPIN, cAdminPin, &nRemainCount);
	printf("Verify New Admin PIN. Return: 0x%08X\n", dwRet);

	//ĿPIN
	nRemainCount = 100;
	dwRet = Dongle_ChangePIN(hDongle, FLAG_ADMINPIN, cAdminPin, AdminPin, nRemainCount);
	printf("Change Admin PIN. Return: 0x%08X\n", dwRet);

	//һָ
	dwRet = Dongle_RFS(hDongle);
	printf("RFS. Return: 0x%08X\n", dwRet);
	
	//رռ
	dwRet = Dongle_Close(hDongle);
	printf("Close Rockey ARM. Return: 0x%08X\n", dwRet);
	return 0;
}
//---------------------------------------------------------------------------
