//---------------------------------------------------------------------------

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
#include <stdio.h>
#include "..\Lib\Dongle_API.h"
int main(int argc, char* argv[])
{
	DWORD dwRet = 0;	
	int nCount = 0;
	int i = 0;
	char AdminPin [] = "FFFFFFFFFFFFFFFF";//ĬϿPIN
	int nRemainCount = 0;

	BYTE  bShareMemory[32];//ڴܴС32ֽ
	BYTE  bDataSec[8192];//ܴС8k
	
	DONGLE_HANDLE hDongle = NULL;
	
	//ö
	dwRet = Dongle_Enum(NULL, &nCount);
	printf("Enum %d Rockey ARM. \n", nCount);
	
	//
	dwRet = Dongle_Open(&hDongle, 0);
	printf("Open Rockey ARM. Return : 0x%08X . \n", dwRet);
	
    //дڴ
	memset(bShareMemory, 0x22, 32);
	dwRet = Dongle_WriteShareMemory(hDongle, bShareMemory, 32);
	printf("Write Share Memory. Return : 0x%08X . \n", dwRet);

	//ڴܴСΪ32ֽ
	dwRet = Dongle_WriteShareMemory(hDongle, bShareMemory, 32);
	printf("Write Share Memory. Return : 0x%08X . \n", dwRet);
	if (DONGLE_SUCCESS == dwRet)
	{
		printf("Share Memory[0~31]: \n");
		for (i = 0; i < 32; i++)
		{
			printf("%02X ", bShareMemory[i]);
			if (i == 15) printf("\n");
		}
		printf("\n");
	}

	//֤PIN
	dwRet = Dongle_VerifyPIN(hDongle, FLAG_ADMINPIN, AdminPin, &nRemainCount);
	printf("Verify Admin PIN. Return: 0x%08X\n", dwRet);

	//дûȨ޿дǰ4k(0~4095),8kдȨ
	memset(bDataSec, 0x33, 8192);
	dwRet = Dongle_WriteData(hDongle, 0, bDataSec, 8192);
	printf("Write data section. Return : 0x%08X . \n", dwRet);

	//
	memset(bDataSec, 0, 8192);
	dwRet = Dongle_ReadData(hDongle, 0, bDataSec, 8192);
	printf("Read data section. Return : 0x%08X . \n", dwRet);
	if (DONGLE_SUCCESS == dwRet)
	{
		printf("Data Section[4096~8191]: \n");
		for (i = 4096; i < 8192; i++)
		{
			printf("%02X ", bDataSec[i]);
			if ((i+1)%16 == 0) printf("\n");
		}
		printf("\n");
	}

	//رռ
	dwRet = Dongle_Close(hDongle);
	printf("Close Rockey ARM. Return: 0x%08X\n", dwRet);

	return 0;
}
//---------------------------------------------------------------------------
