//---------------------------------------------------------------------------

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
#include <stdio.h>
#include "..\Lib\Dongle_API.h"
int main(int argc, char* argv[])
{
	int   nCount = 0;
	int   i = 0;	
	int   nLen = 0;
	BYTE  buffer[1024]; 
	DWORD dwRet = 0;

	BYTE pHashMD5[16];
	BYTE pHashSHA1[20];
	BYTE pHashSM3[32];
	
	DONGLE_HANDLE hDongle = NULL;

	for (i = 0; i < 1024; i++) buffer[i] = i;	
	
	//ö
	dwRet = Dongle_Enum(NULL, &nCount);
	printf("Enum %d Rockey ARM. \n", nCount);
	
	//
	dwRet = Dongle_Open(&hDongle, 0);
	printf("Open Rockey ARM. Return : 0x%08X . \n", dwRet);
	
	//MD5
	memset(pHashMD5, 0, sizeof(pHashMD5));
	dwRet = Dongle_HASH(hDongle, FLAG_HASH_MD5, buffer, 1024, pHashMD5);
	printf("MD5[16]: \n");
	for (i = 0; i < 16; i++) printf("%02X ", pHashMD5[i]);
	printf("\n\n");
	
	//SHA1
	memset(pHashSHA1, 0, sizeof(pHashSHA1));
	dwRet = Dongle_HASH(hDongle, FLAG_HASH_SHA1, buffer, 1024, pHashSHA1);
	printf("SHA1[20]: \n");
	for (i = 0; i < 20; i++) printf("%02X ", pHashSHA1[i]);
	printf("\n\n");

	//SM3
	memset(pHashSM3, 0, sizeof(pHashSM3));
	dwRet = Dongle_HASH(hDongle, FLAG_HASH_SM3, buffer, 1024, pHashSM3);
	printf("SM3[32]: \n");
	for (i = 0; i < 32; i++) printf("%02X ", pHashSM3[i]);
	printf("\n\n");

	dwRet = Dongle_Close(hDongle);
	printf("Close Rockey ARM. Return: 0x%08X\n", dwRet);

	return 0;
}
//---------------------------------------------------------------------------
