//---------------------------------------------------------------------------

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
#include <stdio.h>
#include "..\Lib\Dongle_API.h"
int main(int argc, char* argv[])
{
	int   nCount = 0;
	int   i = 0, j = 0;	
	int   nLen = 0;
	BYTE  seed[32]; 
	DWORD dwRet = 0;
	char AdminPin [] = "FFFFFFFFFFFFFFFF";//ĬϿPIN
	int  nRemainCount = 0;
	
	DONGLE_HANDLE hDongle = NULL;
	DONGLE_INFO dongleInfo[64];
	
	memset(dongleInfo, 0, 64*sizeof(DONGLE_INFO));
	for (i = 0; i < 32; i++) seed[i] = 0x11;

	//ö
	dwRet = Dongle_Enum(dongleInfo, &nCount);
	printf("Enum %d Rockey ARM. \n", nCount);
	
	//
	dwRet = Dongle_Open(&hDongle, 0);
	printf("Open Rockey ARM. Return : 0x%08X . \n", dwRet);

	//֤PIN
	dwRet = Dongle_VerifyPIN(hDongle, FLAG_ADMINPIN, AdminPin, &nRemainCount);
	printf("Verify Admin PIN. Return: 0x%08X\n", dwRet);

	//LEDƵĿ
	dwRet = Dongle_LEDControl(hDongle, LED_OFF);//LED ƹ
	printf("LED Control Off.   Return: 0x%08X\n", dwRet);
	Sleep(2000);

	dwRet = Dongle_LEDControl(hDongle, LED_BLINK);//LED 
	printf("LED Control Blink. Return: 0x%08X\n", dwRet);
	Sleep(2000);

	dwRet = Dongle_LEDControl(hDongle, LED_ON);//LED ƿ
	printf("LED Control On.    Return: 0x%08X\n", dwRet);


	//лͨѶЭ飬л֮cos,л֮´
	if (dongleInfo[0].m_DevType == PROTOCOL_HID)
		dwRet = Dongle_SwitchProtocol(hDongle, PROTOCOL_CCID);
	else
		dwRet = Dongle_SwitchProtocol(hDongle, PROTOCOL_HID);
	printf("Switch protocol. Return: 0x%08X\n", dwRet);

	//رռ
	dwRet = Dongle_Close(hDongle);
	printf("Close Rockey ARM. Return: 0x%08X\n", dwRet);

	return 0;
}
//---------------------------------------------------------------------------
